



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>翻译：ECMAScript 5.1简介</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">翻译：ECMAScript 5.1简介</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-25 14:13:35 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>简介</h3>
<p>ECMAScript 5.1 (或仅 ES5) 是ECMAScript(基于JavaScript的规范)标准最新修正。 与HTML5规范进程本质类似，ES5通过对现有JavaScript方法添加语句和原生ECMAScript对象做合并实现标准化。ES5还引入了一个语法的严格变种，被称为&rdquo;严格模式(strict mode)&rdquo;。</p>
<p>本文我们将介绍一些有用的改变和添加。关于完整列表，请参考<a href="http://www.ecma-international.org/publications/files/ECMA-ST/ECMA-262.pdf" rel="external nofollow noreferrer">官方ECMAScript语言规范</a>附录D和E (PDF下载, 3MB)，或者查看<a href="http://www.ecmascript.org/" rel="external nofollow noreferrer">http://www.ecmascript.org/</a>; 您还可以以HTML形式查看 &ndash;&nbsp;<a href="http://es5.github.com/" rel="external nofollow noreferrer">Michael[tm] Smith非官方的HTML版本说明</a>。</p>
<h3>浏览器支持</h3>
<p>随着Opera 11.60的发布, 所有5大浏览器都支持ES5, 除了一些<a href="http://kristopolous.blogspot.com/2011/11/winners-are-opera-ie-firefox-chrome.html" rel="external nofollow noreferrer">实现的bugs</a>. 除非另有说明，本文中提到的的一切可以用在以下浏览器版本（或更高）：</p>
<ul><li>Opera 11.60</li>
<li>Internet Explorer 9*</li>
<li>Firefox 4</li>
<li>Safari 5.1**</li>
<li>Chrome 13</li></ul>
<p>*&nbsp;<a href="http://msdn.microsoft.com/en-us/library/hh673540%28v=VS.85%29.aspx" rel="external nofollow noreferrer">IE9不支持严格模式</a>&nbsp;&mdash; IE10 添加</p>
<p>** Safari 5.1 仍不支持&nbsp;<code>Function.prototype.bind</code>, 尽管&nbsp;<a href="https://bugs.webkit.org/show_bug.cgi?id=26382" rel="external nofollow noreferrer"><code>Function.prototype.bind</code>现在已经被Webkit所支持</a>。</p>
<p>对于旧版浏览器的支持信息，您可以查看Juriy Zaytsev很赞的&nbsp;<a href="http://kangax.github.com/es5-compat-table/" rel="external nofollow noreferrer">ECMAScript 5 兼容性表</a>。</p>
<h3>ES5的严格模式</h3>
<p>严格模式给作者提供了选择一个限制性更强语言变种的方式&mdash;&mdash;给作者提供额外的可靠性给用户提供额外的安全性。在JS文件或是函数的顶部添加<code>"use strict"</code>即可启用严格模式。因为<code>"use strict"</code>就是个字符串，因此其会被旧版浏览器安全地忽视。</p>
<div>
<pre class="prettyprint linenums"><code>"use strict";</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>function strict(){<br />
  "use strict";<br />
  //...<br />
}

function sloppy(){<br />
  eval("window.foo = 'bar'");<br />
}</code></pre>
</div>
<p>在严格模式下运行脚本，不少导致提醒或buggy行为的事情会抛出错误，例如：</p>
<ul><li>未声明的变量赋值抛出一个<code>ReferenceError</code>, 而不是创建一个全局变量。</li>
<li>不止一次对对象字面量分配相同的属性会抛出<code>SyntaxError</code>.</li>
<li>使用<code>with</code>语句抛出<code>SyntaxError</code>.</li></ul>
<p><a href="http://msdn.microsoft.com/en-us/library/br230269%28v=vs.94%29.aspx" rel="external nofollow noreferrer">MDSN的严格模式文章</a>有个关于所有这些差异很有用的总结表格。</p>
<p><img referrerpolicy="no-referrer"src="http://image.zhangxinxu.com/image/blog/201201/2012-01-04_180104.png" data-src="http://image.zhangxinxu.com/image/blog/201201/2012-01-04_180104.png" /></p>
<h3>JSON</h3>
<p>ES5提供一个全局的<code>JSON</code>对象，用来序列化(<code>JSON.stringify</code>)和反序列化(JSON.parse)对象为JSON格式。</p>
<p>对于老的浏览器，可以考虑使用Douglas Crockford的<a href="https://github.com/douglascrockford/JSON-js/blob/master/json2.js" rel="external nofollow noreferrer">json2.js</a>, 可以让旧的浏览器实现同样的功能（原始支持功能测试后）。</p>
<p><strong><code>JSON.parse(text [, reviver])</code></strong></p>
<p><code>JSON.parse</code>接受文本(JSON格式)并转换成一个ECMAScript值。该可选的reviver参数是有带有<code>key</code>和<code>value</code>两个参数的函数，其作用于结果&mdash;&mdash;让过滤和转换返回值成为可能。</p>
<div>
<pre class="prettyprint linenums"><code>&gt;&gt; var result = JSON.parse('{"a": 1, "b": "2"}');<br />
Object

&gt;&gt; result.b<br />
"2"</code></pre>
</div>
<p>如果我们想确保解析的值是个整数，我们可以使用reviver方法。</p>
<div>
<pre class="prettyprint linenums"><code>var result = JSON.parse('{"a": 1, "b": "2"}', function(key, value){<br />
  if (typeof value == 'string'){<br />
    return parseInt(value);<br />
  } else {<br />
    return value;<br />
  }<br />
})

&gt;&gt; result.b<br />
2</code></pre>
</div>
<p><strong><code>JSON.stringify(value [, replacer [, space]])</code></strong></p>
<p><code>JSON.stringify</code>允许作者接受一个ECMAScript值然后转换成JSON格式的字符串。 在其最简单的形式中，<code>JSON.stringify</code>接受一个值返回一个字符串，</p>
<div>
<pre class="prettyprint linenums"><code>&gt;&gt;&gt; var mike = JSON.stringify({mike: "taylor"})<br />
undefined

&gt;&gt; mike<br />
'{"mike": "taylor"}'

&gt;&gt; typeof mike<br />
"string"</code></pre>
</div>
<p>如果我们需要改变值字符串化的方式，或是对我们选择的提供过滤，我们可以将其传给replacer函数。例如，我们想过滤出即将被字符串化的对象中值为13的属性：</p>
<div>
<pre class="prettyprint linenums"><code>var nums = {<br />
  "first": 7,<br />
  "second": 14,<br />
  "third": 13<br />
}

var luckyNums = JSON.stringify(nums, function(key, value){<br />
  if (value == 13) {<br />
    return undefined;<br />
  } else {<br />
    return value;<br />
  }<br />
});

&gt;&gt; luckyNums<br />
'{"first": 7, "second": 14}'</code></pre>
</div>
<p>如果replacer方法返回<code>undefined</code>, 则键值对就不会包含在最终的JSON中。我们同样可以传递一个space参数以便获得返回结果的可读性帮助。space参数可以是个数字，表明了作缩进的JSON字符串或字符串每个水平上缩进的空格数。如果参数是个超过10的数值，或是超过10个字符的字符串，将导致取数值10或是截取前10个字符。</p>
<div>
<pre class="prettyprint linenums"><code>var luckyNums = JSON.stringify(nums, function(key, value) {<br />
  if (value == 13) {<br />
    return undefined;<br />
  } else {<br />
    return value;<br />
  }<br />
}, 2);

&gt;&gt; luckyNums<br />
'{<br />
  "first":7,<br />
  "second":14<br />
}'</code></pre>
</div>
<h3>附加对象</h3>
<p>下面的方法是添加到<code>Object</code>上的构造器：</p>
<ul><li><code>Object.getPrototypeOf</code></li>
<li><code>Object.getOwnPropertyDescriptor</code></li>
<li><code>Object.getOwnPropertyNames</code></li>
<li><code>Object.create</code></li>
<li><code>Object.defineProperty</code></li>
<li><code>Object.defineProperties</code></li>
<li><code>Object.seal</code></li>
<li><code>Object.freeze</code></li>
<li><code>Object.preventExtensions</code></li>
<li><code>Object.isSealed</code></li>
<li><code>Object.isFrozen</code></li>
<li><code>Object.isExtensible</code></li>
<li><code>Object.keys</code></li></ul>
<p>这些新增的好处之一是对象的属性有了更多控制，例如哪些是允许被修改的，哪些是可以枚举的，哪些是可以删除的等。这个的实现通过程序访问对象的<em>属性描述符(property descriptors)</em>. 例如：</p>
<div>
<pre class="prettyprint linenums"><code>var cat = {};

Object.defineProperty(cat, "name", {<br />
  value: "Maru",<br />
  writable: false,<br />
  enumerable: true,<br />
  configurable: false<br />
});

Object.defineProperty(cat, "skill", {<br />
  value: "exploring boxes",<br />
  writable: true,<br />
  enumerable: true,<br />
  configurable: true<br />
});</code></pre>
</div>
<p>对于我们的<code>cat</code>对象, 其名字<code>name</code>不能被改变，但是会出现在<code>for-in</code>循环中。在其他方面，Maru擅长探索盒子(exploring boxes), 但是可以在将来改变，因为<code>skill</code>属性是<code>writable</code>和<code>configurable</code>的。</p>
<p>在之后的文章我们将详细探讨所有附加的对象。</p>
<h3>额外的数组</h3>
<p>以下方法添加到了Array<code>prototype</code>对象上:</p>
<ul><li><code>Array.prototype.indexOf</code></li>
<li><code>Array.prototype.lastIndexOf</code></li>
<li><code>Array.prototype.every</code></li>
<li><code>Array.prototype.some</code></li>
<li><code>Array.prototype.forEach</code></li>
<li><code>Array.prototype.map</code></li>
<li><code>Array.prototype.filter</code></li>
<li><code>Array.prototype.reduce</code></li>
<li><code>Array.prototype.reduceRight</code></li></ul>
<p>关于<a href="http://dev.opera.com/articles/view/javascript-array-extras-in-detail/" rel="external nofollow noreferrer">ES5数组&rdquo;extras&rdquo;</a>&nbsp;Dmitry Soshnikov写过一篇有深度的参考文章。</p>
<p>Dmitry的文章中有一个没有提到，就是<code>Array.isArray</code>, 正如你看到的，这厮直接写在了<code>Array</code>构造器上，而不是<code>prototype</code>对象上。<code>Array.isArray</code>会按照你所期待的那样去做 &mdash; 这是一个根据参数的[[Class]]内部属性是否是&rdquo;Array&rdquo;返回<code>true</code>或<code>false</code>.</p>
<div>
<pre class="prettyprint linenums"><code>Array.isArray("NO U")<br />
&gt;&gt; false

Array.isArray(["NO", "U"])<br />
&gt;&gt; true</code></pre>
</div>
<p>在ES3中，唯一可靠的确定一个值是数组的方式就是使用<a href="http://www.songhaysystem.com/kb/number/2076072056/subject/htmlscrp" rel="external nofollow noreferrer">&ldquo;the Miller Device&rdquo;</a>, 即比对一个数组其内在的<code>[[Class]]</code>属性。</p>
<div>
<pre class="prettyprint linenums"><code>Object.prototype.toString.apply(value) === '[object Array]'</code></pre>
</div>
<h3><code>Function.prototype.bind(thisArg [, arg1 [, arg2, &hellip;]])</code></h3>
<p><code>Function.prototype.bind</code>返回一个新的函数对象，该函数对象的<em>this</em>绑定到了<code>thisArg</code>参数上。从本质上讲，这允许你在其他对象链中执行一个函数。</p>
<div>
<pre class="prettyprint linenums"><code>function locate(){<br />
  console.log(this.location);<br />
}

function Maru(location){<br />
  this.location = location;<br />
}

var kitty = new Maru("cardboard box");

var locateMaru = locate.bind(kitty);

locateMaru();</code></pre>
</div>
<p>在这个例子中，我们将Maru对象的上下文应用在<code>location</code>函数中。因为<code>location</code>是个全局对象的属性，其<code>this</code>值就是全局对象(<code>window</code>)。在这种情况下，我们向上寻找cat, 并不是<code>Location</code>对象，因为我们可以通过绑定的总是<code>kitty</code>的<code>this</code>值创建一个新方法<code>locateMaru</code>.</p>
<h3>补充参考</h3>
<ul><li><a href="http://ejohn.org/blog/ecmascript-5-objects-and-properties/" rel="external nofollow noreferrer">ECMAScript 5 对象和属性</a>&nbsp;by John Resig</li>
<li><a href="http://yehudakatz.com/2011/08/11/understanding-javascript-function-invocation-and-this/" rel="external nofollow noreferrer">理解JavaScript函数调用和&rdquo;this&rdquo;</a>&nbsp;by Yehuda Katz</li>
<li><a href="http://javascriptweblog.wordpress.com/2011/05/03/javascript-strict-mode/" rel="external nofollow noreferrer">JavaScript严格模式</a>&nbsp;by Angus Croll</li>
<li>ECMA-262-5详细&nbsp;<a href="http://dmitrysoshnikov.com/ecmascript/es5-chapter-0-introduction/" rel="external nofollow noreferrer">介绍</a>&nbsp;by Dmitry Soshnikov</li>
<li><a href="http://kangax.github.com/es5-compat-table/" rel="external nofollow noreferrer">ECMAScript 5 兼容性表</a>&nbsp;by Juriy Zaytsev</li></ul>
<p>本文许可自<a href="http://creativecommons.org/licenses/by/3.0/" rel="external nofollow noreferrer">Creative Commons Attribution 3.0 Unported</a>许可。</p>
<p>原创文章，转载请注明来自<a href="http://www.zhangxinxu.com/" rel="external nofollow noreferrer">张鑫旭-鑫空间-鑫生活</a>[<a href="http://www.zhangxinxu.com/" rel="external nofollow noreferrer">http://www.zhangxinxu.com</a>]<br />本文地址：<a href="http://www.zhangxinxu.com/wordpress/?p=2148" rel="external nofollow noreferrer">http://www.zhangxinxu.com/wordpress/?p=2148</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7dg3kq.html">浅析tomcat nio 配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/49ggwml9.html">linux 程序管理与SElinux</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z0j4vq.html">ztree  addNode editName removeNode</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1zgkr9.html">SQLite 入门教程（四）增删改查，有讲究</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vg4lj8.html">linux程序自启动和新建linux服务的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zg7d59.html">AOP annotation</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgzzo48.html">在LINUX的命令提示符及CMD命令提示符中显示时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjdppk8.html">如何搭建NTP服务（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyy6xj9.html">用python做自己主动化測试--对server端的自己主动化測试（3）-很多其它http client实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgyk478.html">设置git账号并生成新的ssh（切换电脑用户之后）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zy5yk9.html">2017OKR年终回顾与2018OKR初步规划</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj627lq.html">Android音视频之AudioRecord录音&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o13n1eq.html">力扣（LeetCode） 821&period; 字符的最短距离</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllzjp1q.html">Java动态代理总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjegkvq.html">js基础知识：闭包，事件处理，原型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv5x5dq.html">逻辑斯蒂回归VS决策树VS随机森林</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp5w649.html">MVC仓储使用join</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2xpwd8.html">Servlet字符编码过滤器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4royeq.html">20162314 Experiment 4 - Graph</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r4g7rr8.html">list&amp;lt&semi;&quest;&amp;gt&semi;转换成 对应的 class</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qvvnm01q.html">2015AppStore 上传步骤及常见问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvnmxyq.html">asp&period;net中为什么修改了配置文件后我们不需要重启IIS</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4ywoy5q.html">cocos2d-x 绘制基本图元</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm7r219.html">CSS3&colon;clip-path具体解释</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xye208.html">Unsupervised Feature Learning and Deep Learning&lpar;UFLDL&rpar; Exercise 总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydxkemq.html">IAP升级功能编写初期的一些困惑与疑问---完毕功能后的总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xkmy09.html">CSS3画腾讯QQ图标 无图片和js参考</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xk5nw9.html">Java基础知识强化之IO流笔记62：三种方式实现键盘录入</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z2gd69.html">IEnumerable 和 IQueryable</a>
			</li>
						<li><a href="https://www.batexi.com/a/96okj039.html">PAT L1-009&period; N个数求和</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
